import os
import csv
import netCDF4
import pandas as pd
import numpy as np

def netcdfvartostrs(var):
    return [''.join([i.decode('UTF-8') for i in var[j]]).replace(' ','') for j in range(len(var))]


inpath='/esarchive/obs/argo/bgc/original_files/ftp.ifremer.fr/dac/'
outpath='/esarchive/obs/argo/bgc/'


orgs=[i for i in os.listdir(inpath) if os.path.isdir(inpath+'/'+i)]
# if 'csiro' in orgs: ## removed because these organisations do not correct the data
#     orgs.remove('csiro')
# if 'incois' in orgs:
#     orgs.remove('incois')

data={}
data['floats']=[]
data['institute']=[]
#allsensors=[] ## for all data
data['BACKSCATTERINGMETER_BBP700']=[]
scatteros=0
for org in orgs:
    print('doing ' +org)
    # if len(data['floats'])==100:
    #     break
    os.chdir(inpath + org)
    floatids=os.listdir(inpath + org)
    print(len(floatids))
    withdata=[]
    for floatid in floatids:
        #print(floatid)
        if 'profiles' in os.listdir(inpath+org+'/'+floatid+'/'):
            #print(floatid)
            #print('profile')
            #os.chdir(inpath+org+'/'+floatid+'/')
            #withdata.append(floatid)
            A=os.listdir(inpath + org + '/' + floatid + '/profiles/')
            prodata = netCDF4.Dataset(inpath + org + '/' + floatid + '/profiles/' + A[0], 'r')
            #if 'BBP700' in [str(i) for i in prodata.variables.keys()]:
                #print('yes, bioptic')
            #else:
                #print('no')
            #prodata.close()
            if floatid + '_meta.nc' in os.listdir(inpath + org + '/' + floatid + '/'):
                #print('traj')
                if floatid + '_BDtraj.nc' in os.listdir(inpath + org + '/' + floatid + '/'):
                    print(floatid,' is delayed')
                    trajdata = netCDF4.Dataset(inpath + org + '/' + floatid + '/' + floatid + '_BDtraj.nc', 'r')
                    if 'BBP700' in trajdata.variables.keys():
                        #print('yes, its biooptic')
                        withdata.append(floatid)
                    #else:
                        #print('no')
                    trajdata.close()
                elif floatid + '_BRtraj.nc' in os.listdir(inpath + org + '/' + floatid + '/'):
                    #print(floatid, ' is real')
                    trajdata = netCDF4.Dataset(inpath + org + '/' + floatid + '/' + floatid + '_BRtraj.nc', 'r')

                    if 'BBP700' in trajdata.variables.keys():
                        print(floatid,'yes, its biooptic')
                        withdata.append(floatid)
                    #else:
                        #print('no')
                    trajdata.close()
                #print(trajdata.variables.keys())



    print(len(withdata))

    for floatid in withdata:
        # if len(data['floats']) == 100:
        #     break
        floatdata = netCDF4.Dataset(inpath+org+'/'+floatid+'/'+floatid+'_meta.nc', 'r')
        sensor = np.array(floatdata.variables['SENSOR'])
        sensor = netcdfvartostrs(sensor)
        sensor_maker = np.array(floatdata.variables['SENSOR_MAKER'])
        sensor_maker = netcdfvartostrs(sensor_maker)
        sensor_model = np.array(floatdata.variables['SENSOR_MODEL'])
        sensor_model = netcdfvartostrs(sensor_model)

        data['floats'].append(floatid)
        data['institute'].append(org)

        # for s in sensor:             ### for all sensors of all variables
        #     if s not in allsensors:
        #         allsensors.append(s)
        #         if len(data['floats'])==1:
        #             data[s]=[]
        #         else:
        #             data[s]=['-' for i in range(len(data['floats'])-1)]

        #for sind in range(len)
        # for s in allsensors:
        #     if s in sensor:
        #         sind=sensor.index(s)
        #         data[s].append(sensor_model[sind]+' by '+sensor_maker[sind])
        #     else:
        #         data[s].append('-')
        print(floatid)
        print(sensor)
        if 'BACKSCATTERINGMETER_BBP700' in sensor:
            sind=sensor.index('BACKSCATTERINGMETER_BBP700')
            data['BACKSCATTERINGMETER_BBP700'].append(sensor_model[sind]+' by '+sensor_maker[sind])
        elif 'SCATTEROMETER_BBP' in sensor:
            scatteros=scatteros+1
            sind = sensor.index('SCATTEROMETER_BBP')
            data['BACKSCATTERINGMETER_BBP700'].append('(SCATTEROMETER_BBP)'+ sensor_model[sind] + ' by ' + sensor_maker[sind])
        else:
            data['BACKSCATTERINGMETER_BBP700'].append('-')
        floatdata.close()


# for key in data.keys():
#     print(key,len(data[key]),data[key])

df=pd.DataFrame(data)
print(df)
print(scatteros)
# df=df.to_csv()
#
# os.chdir(outpath)
#
# f= open("sensors_metatraj.csv","w+")
#
# f.write(df)
#
# print('done')

types=[]
for i in data['BACKSCATTERINGMETER_BBP700']:
    if i not in types:
        types.append(i)
for i in types:
    print(i)
    print(data['BACKSCATTERINGMETER_BBP700'].count(i))